myCustomFilter = false

function MyLFGListUtil_SortSearchResults(resID1, resID2)
  -- local id, activityID, name, description, voice, iLevel, time, nBNetFriends, nFriends, nGuildies, isDelisted = C_LFGList.GetSearchResultInfo(resID)
  local id1,_,_,_,_,_,time1,nBNet1,nFriends1,nGuildies1,_ = C_LFGList.GetSearchResultInfo(resID1)
  local id2,_,_,_,_,_,time2,nBNet2,nFriends2,nGuildies2,_ = C_LFGList.GetSearchResultInfo(resID2)
  if (nBNet1 ~= nBNet2) then
    return nBNet1 > nBNet2
  end
  if (nFriends1 ~= nFriends2) then
    return nFriends1 > nFriends2
  end
  if (nGuildies1 ~= nGuildies2) then
    return nGuildies1 > nGuildies2
  end
  if (time1 ~= time2) then
    return time1 < time2
  end
  return id1 < id2
end

function LFGListUtil_SortSearchResults(results)
  table.sort(results, MyLFGListUtil_SortSearchResults)
end

function LFGListSearchPanel_DoSearch(self)
	C_LFGList.Search(self.categoryID, "", self.filters, self.preferredFilters)
	self.searching = true
	self.searchFailed = false
	self.selectedResult = nil
	myCustomFilter = true
	LFGListSearchPanel_UpdateResultList(self)
	LFGListSearchPanel_UpdateResults(self)
end

function MyIsIgnored(name)
	local numIgnores = GetNumIgnores()
	for i = 1,numIgnores do
		if GetIgnoreName(i) == name then
			return true
		end
	end
	return false
end

function LFGListSearchPanel_UpdateResultList(self)
	self.totalResults, self.results = C_LFGList.GetSearchResults()
	myResults = {}
	for i,v in ipairs(self.results) do
		local _,activityID,name,comment,_,_,_,_,_,_,_,leaderName = C_LFGList.GetSearchResultInfo(v)
		local activity = select(1,C_LFGList.GetActivityInfo(activityID))
		activity = activity:lower()
		name = name:lower()
		comment = comment:lower()
		local addMe = true
		for word in (self.SearchBox:GetText()):gmatch("%S+") do
			word = word:lower()
			
			if activity:find(word,1,true)==nil and name:find(word,1,true)==nil and comment:find(word,1,true)==nil then
				addMe = false
				break
			end
		end
		if addMe and not MyIsIgnored(leaderName) then
			table.insert(myResults, v)
		end
	end
	self.totalResults = table.getn(myResults)
	self.results = myResults
	self.applications = C_LFGList.GetApplications()
	LFGListUtil_SortSearchResults(self.results)
end


local LFG_LIST_SEARCH_ENTRY_MENU = {
	{
		text = nil,	--Group name goes here
		isTitle = true,
		notCheckable = true,
	},
	{
		text = WHISPER_LEADER,
		func = function(_, name) ChatFrame_SendTell(name); end,
		notCheckable = true,
		arg1 = nil, --Leader name goes here
		disabled = nil, --Disabled if we don't have a leader name yet or you haven't applied
		tooltipWhileDisabled = 1,
		tooltipOnButton = 1,
		tooltipTitle = nil, --The title to display on mouseover
		tooltipText = nil, --The text to display on mouseover
	},
	{
		text = "Ignore Leader",
		func = function(_, name) AddIgnore(name); end,
		notCheckable = true,
		arg1 = nil, --Leader name goes here
		disabled = nil, --Disabled if we don't have a leader name yet or you haven't applied
		tooltipWhileDisabled = 1,
		tooltipOnButton = 1,
		tooltipTitle = nil, --The title to display on mouseover
		tooltipText = nil, --The text to display on mouseover
	},
	{
		text = LFG_LIST_REPORT_GROUP_FOR,
		hasArrow = true,
		notCheckable = true,
		menuList = {
			{
				text = LFG_LIST_BAD_NAME,
				func = function(_, id) C_LFGList.ReportSearchResult(id, "lfglistname"); end,
				arg1 = nil, --Search result ID goes here
				notCheckable = true,
			},
			{
				text = LFG_LIST_BAD_DESCRIPTION,
				func = function(_, id) C_LFGList.ReportSearchResult(id, "lfglistcomment"); end,
				arg1 = nil, --Search reuslt ID goes here
				notCheckable = true,
				disabled = nil,	--Disabled if the description is just an empty string
			},
			{
				text = LFG_LIST_BAD_VOICE_CHAT_COMMENT,
				func = function(_, id) C_LFGList.ReportSearchResult(id, "lfglistvoicechat"); end,
				arg1 = nil, --Search reuslt ID goes here
				notCheckable = true,
				disabled = nil,	--Disabled if the description is just an empty string
			},
			{
				text = LFG_LIST_BAD_LEADER_NAME,
				func = function(_, id) C_LFGList.ReportSearchResult(id, "badplayername"); end,
				arg1 = nil, --Search reuslt ID goes here
				notCheckable = true,
				disabled = nil,	--Disabled if we don't have a name for the leader
			},
		},
	},
	{
		text = CANCEL,
		notCheckable = true,
	},
};

function LFGListUtil_GetSearchEntryMenu(resultID)
	local id, activityID, name, comment, voiceChat, iLvl, age, numBNetFriends, numCharFriends, numGuildMates, isDelisted, leaderName = C_LFGList.GetSearchResultInfo(resultID);
	local _, appStatus, pendingStatus, appDuration = C_LFGList.GetApplicationInfo(resultID);
	LFG_LIST_SEARCH_ENTRY_MENU[1].text = name;
	LFG_LIST_SEARCH_ENTRY_MENU[2].arg1 = leaderName;
	local applied = (appStatus == "applied" or appStatus == "invited");
	LFG_LIST_SEARCH_ENTRY_MENU[2].disabled = not leaderName;-- or not applied;
	LFG_LIST_SEARCH_ENTRY_MENU[2].tooltipTitle = (not disabled) and WHISPER--(not applied) and WHISPER
	LFG_LIST_SEARCH_ENTRY_MENU[2].tooltipText = (not disabled) and ("Whisper "..leaderName)--(not applied) and LFG_LIST_MUST_SIGN_UP_TO_WHISPER;
	LFG_LIST_SEARCH_ENTRY_MENU[3].arg1 = leaderName;
	LFG_LIST_SEARCH_ENTRY_MENU[3].disabled = not leaderName;-- or not applied;
	LFG_LIST_SEARCH_ENTRY_MENU[3].tooltipTitle = (not disabled) and "Ignore"--(not applied) and WHISPER
	LFG_LIST_SEARCH_ENTRY_MENU[3].tooltipText = (not disabled) and ("Ignore "..leaderName)--(not applied) and LFG_LIST_MUST_SIGN_UP_TO_WHISPER;
	LFG_LIST_SEARCH_ENTRY_MENU[4].menuList[1].arg1 = resultID;
	LFG_LIST_SEARCH_ENTRY_MENU[4].menuList[2].arg1 = resultID;
	LFG_LIST_SEARCH_ENTRY_MENU[4].menuList[2].disabled = (comment == "");
	LFG_LIST_SEARCH_ENTRY_MENU[4].menuList[3].arg1 = resultID;
	LFG_LIST_SEARCH_ENTRY_MENU[4].menuList[3].disabled = (voiceChat == "");
	LFG_LIST_SEARCH_ENTRY_MENU[4].menuList[4].arg1 = resultID;
	LFG_LIST_SEARCH_ENTRY_MENU[4].menuList[4].disabled = not leaderName;
	return LFG_LIST_SEARCH_ENTRY_MENU;
end